"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FcrParticipantsMoreActions = void 0;
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.includes.js");
require("core-js/modules/es.array.is-array.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.string.includes.js");
require("core-js/modules/esnext.async-iterator.filter.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.filter.js");
var _dropMenu = require("../../drop-menu");
var _icon = require("../../icon");
var _type = require("../../icon/type");
var _attendee = require("../attendee");
require("./index.css");
var _i18next = require("i18next");
var _cameraState = require("../../room-screen-share-state-bar/camera-state");
var _jsxRuntime = require("react/jsx-runtime");
var FcrParticipantsMoreActions = exports.FcrParticipantsMoreActions = function FcrParticipantsMoreActions(props) {
  var isMe = props.isMe,
    userId = props.userId,
    hasVideo = props.hasVideo,
    hasAudio = props.hasAudio,
    onParticipantsButtonClick = props.onParticipantsButtonClick,
    userName = props.userName,
    userRole = props.userRole,
    isPin = props.isPin,
    hasPinnedStream = props.hasPinnedStream,
    allowedOperations = props.allowedOperations,
    audioDeviceType = props.audioDeviceType,
    userType = props.userType,
    hideActions = props.hideActions;
  var cameraStateType = !hasVideo ? 'primary' : 'danger';
  var allOperationMenu = [{
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_cameraState.CameraState, {
      isCameraMuted: true
    }),
    title: (0, _i18next.t)('fmt_device_label_video_start'),
    key: 'start_video',
    type: cameraStateType,
    canOperation: !hasVideo && userType !== 'phone',
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.UNMUTE_VIDEO, userId);
    },
    classNames: 'fcr-drop-menu-option-with-under-line'
  }, {
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_cameraState.CameraState, {
      isCameraMuted: true
    }),
    title: (0, _i18next.t)('fmt_sip_button_opencamera'),
    key: 'request_start_video',
    type: 'primary',
    canOperation: !hasVideo && !isMe && userType !== 'phone',
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.UNMUTE_VIDEO, userId);
    },
    classNames: 'fcr-drop-menu-option-with-under-line'
  }, {
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_cameraState.CameraState, {
      isCameraMuted: false
    }),
    title: /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      children: (0, _i18next.t)('fmt_device_label_video_stop')
    }),
    key: 'stop_video',
    type: cameraStateType,
    canOperation: hasVideo && userType !== 'phone',
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.MUTE_VIDEO, userId);
    },
    classNames: 'fcr-drop-menu-option-with-under-line'
  }, {
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_MOBILE_CHAT3,
      size: 20,
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_icontext5)'
      }
    }),
    title: (0, _i18next.t)('fmt_attendies_label_privatechat'),
    key: 'private_chat',
    type: 'primary',
    canOperation: !isMe && userType !== 'phone',
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.PRIVATE_CHAT, userId);
    }
  }, {
    icon: isPin ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_UNPIN,
      size: 20
    }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_PINPAGE,
      size: 20,
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_icontext5)'
      }
    }),
    title: isPin ? /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      children: (0, _i18next.t)('fmt_attendies_options_cancelfixed')
    }) : hasPinnedStream ? (0, _i18next.t)('fmt_attendies_options_replacefixed') : (0, _i18next.t)('fmt_attendies_options_fixfirst'),
    key: 'pin',
    type: isPin ? 'danger' : 'primary',
    canOperation: userType === 'normal' || userType === 'meeting-system' && hasVideo,
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(isPin ? _attendee.ParticipantActionType.REMOVE_PIN : _attendee.ParticipantActionType.ADD_PIN, userId);
    },
    classNames: 'fcr-drop-menu-option-with-under-line'
  }, {
    title: (0, _i18next.t)('fmt_attendies_options_sethost'),
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_HOST2,
      size: 20,
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_icontext5)'
      }
    }),
    key: 'set_as_host',
    canOperation: userRole !== _attendee.FcrUserRole.HOST && userType === 'normal',
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.SET_AS_HOST, userId);
    }
  }, {
    title: (0, _i18next.t)('fmt_attendies_options_setcohost'),
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_COHOST2,
      size: 20,
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_icontext5)'
      }
    }),
    key: 'set_as_co_host',
    type: 'primary',
    canOperation: userRole !== _attendee.FcrUserRole.COHOST && userType === 'normal',
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.SET_AS_CO_HOST, userId);
    }
  }, {
    title: (0, _i18next.t)('fmt_attendies_options_revokecohost'),
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_PINPAGE,
      size: 20,
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_icontext5)'
      }
    }),
    key: 'revoke_co_host',
    type: 'danger',
    canOperation: userRole === _attendee.FcrUserRole.COHOST && userType === 'normal',
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.SET_AS_ATTENDEE, userId);
    }
  }, {
    title: (0, _i18next.t)('fmt_modules_tips_mergevideo'),
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_MOBILE_CAMERA2,
      size: 20,
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_icontext5)'
      }
    }),
    key: 'merge_video',
    type: 'primary',
    canOperation: userType === 'phone',
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.MERGE_VIDEO, userId);
    }
  }, {
    title: (0, _i18next.t)('fmt_attendies_options_putinwaitingroom'),
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_PUT_WAITING_ROOM,
      size: 20,
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_ramp_red6)'
      }
    }),
    key: 'put_into_waiting_room',
    type: 'danger',
    canOperation: true,
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.PUT_IN_WAITING_ROOM, userId);
    }
  }, {
    title: (0, _i18next.t)('fmt_attendies_button_remove'),
    icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_SETTING_NONE,
      size: 20,
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_ramp_red6)'
      }
    }),
    key: 'kick_out',
    type: 'danger',
    canOperation: true,
    onButtonClick: function onButtonClick() {
      onParticipantsButtonClick(_attendee.ParticipantActionType.KICK_OUT, userId);
    }
  }];
  var currentActions = Array.isArray(allowedOperations) && allowedOperations.length > 0 ? allOperationMenu.filter(function (item) {
    return allowedOperations.includes(item.key) && item.canOperation;
  }).filter(function (item) {
    if (hideActions && hideActions.length) {
      return hideActions.includes(item.key) ? false : true;
    } else {
      return true;
    }
  }) : allOperationMenu;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_dropMenu.FcrDropMenu, {
    className: "fcr-participants-more-dropmenu",
    title: userName,
    options: currentActions
  });
};